<?php

  class mw_app{

    var $env;

    function set_env(&$env){
      $this->env =& $env;
    }

    function env(){
      return $this->env;
    }

    function init($config_file){
      require $config_file;
      $PATHES["mw_dir"] .= $PATHES["mw_dir"] && substr($PATHES["mw_dir"], -1) != "/" ? "/" : "";
      $PATHES["mw_path"] .= $PATHES["mw_path"] && substr($PATHES["mw_path"], -1) != "/" ? "/" : "";
      if(!isset($CONFIG)) $CONFIG = array();
      $env = false;
      $this->set_env($env);
      if(
            ($sxml_class_file = (file_exists($PATHES["mw_dir"]."libs/sxml.php") ? $PATHES["mw_dir"]."libs/sxml.php" : ""))
        &&  ($empty_class_file = (file_exists($PATHES["mw_dir"]."libs/empty_class.php") ? $PATHES["mw_dir"]."libs/empty_class.php" : ""))
        &&  ($env_class_file = (file_exists($PATHES["mw_dir"]."env/mw_env.php") ? $PATHES["mw_dir"]."env/mw_env.php" : ""))
      ){
        if(!class_exists("sxml")) require_once $sxml_class_file;
        if(!class_exists("empty_class")) require_once $empty_class_file;
        if(!class_exists("mw_env")) require_once $env_class_file;
        if(
              class_exists("sxml")
          &&  class_exists("empty_class")
          &&  class_exists("mw_env")
        ){
          $env = new mw_env(true);
          $this->set_env($env);
          $env->load_modules($PATHES["mw_dir"], "env/modules/");
          $env->set_config_file($config_file);
          $env->set_PATHES($PATHES);
          $env->init_plugins();
          $env->load_config($bdd, $CONFIG);
          $env->init();
        }
      }
      return $this->env();
    }

    function run($etat = "", $params = array(), $valid_role = true){
      $env = $this->env();
      $etat = ($etat === false ? false : ($etat ? $etat : (isset($_GET[$env->param("e")]) ? $_GET[$env->param("e")] : "")));
      if($etat !== false) $env->run($etat, $params, $valid_role);
    }
  
    function display(){
      $env = $this->env();
      if($env->etat_is_valid()){
        $template = $env->get_template();
        $layout = $env->init_layout();
        $template->render_layout($layout);
      }
    }

  }

?>